## compute 0.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(BoostCompute)

set(CMAKE_MODULE_PATH ${BoostCompute_SOURCE_DIR}/cmake)

# find OpenCL
find_package(OpenCL REQUIRED)
include_directories(SYSTEM ${OPENCL_INCLUDE_DIRS})

# find Boost
find_package(Boost 1.48 REQUIRED)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

# optional support for c++11
option(BOOST_COMPUTE_USE_CPP11 "Use C++11 features" OFF)
if(${BOOST_COMPUTE_USE_CPP11})
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()

# optional support for offline-caching
option(BOOST_COMPUTE_USE_OFFLINE_CACHE "Use offline cache for OpenCL program binaries" OFF)
if(${BOOST_COMPUTE_USE_OFFLINE_CACHE})
  add_definitions(-DBOOST_COMPUTE_USE_OFFLINE_CACHE)
endif()

# thread-safety options
option(BOOST_COMPUTE_THREAD_SAFE "Compile with BOOST_COMPUTE_THREAD_SAFE defined" OFF)
if(${BOOST_COMPUTE_THREAD_SAFE})
  add_definitions(-DBOOST_COMPUTE_THREAD_SAFE)
  if(${BOOST_COMPUTE_USE_CPP11})
    add_definitions(-DBOOST_COMPUTE_HAVE_THREAD_LOCAL)
  endif()
endif()

# optional third-party libraries
option(BOOST_COMPUTE_HAVE_EIGEN "Have Eigen" OFF)
option(BOOST_COMPUTE_HAVE_OPENCV "Have OpenCV" OFF)
option(BOOST_COMPUTE_HAVE_QT "Have Qt" OFF)
option(BOOST_COMPUTE_HAVE_VTK "Have VTK" OFF)
option(BOOST_COMPUTE_HAVE_CUDA "Have CUDA" OFF)
option(BOOST_COMPUTE_HAVE_TBB "Have TBB" OFF)

include_directories(include)

if(${OpenCL_HEADER_CL_EXT_FOUND})
  add_definitions(-DBOOST_COMPUTE_HAVE_HDR_CL_EXT)
endif()

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  add_definitions(-D_SCL_SECURE_NO_WARNINGS)
endif()

# compiler options
option(BOOST_COMPUTE_ENABLE_COVERAGE "Enable code coverage generation" OFF)

option(BOOST_COMPUTE_BUILD_TESTS "Build the Boost.Compute tests" OFF)
if(${BOOST_COMPUTE_BUILD_TESTS})
  enable_testing()
  add_subdirectory(test)
endif()

option(BOOST_COMPUTE_BUILD_BENCHMARKS "Build the Boost.Compute benchmarks" OFF)
if(${BOOST_COMPUTE_BUILD_BENCHMARKS})
  add_subdirectory(perf)
endif()

option(BOOST_COMPUTE_BUILD_EXAMPLES "Build the Boost.Compute examples" OFF)
if(${BOOST_COMPUTE_BUILD_EXAMPLES})
  add_subdirectory(example)
endif()

# configure cmake config file
configure_file(
  cmake/BoostComputeConfig.cmake.in
  ${BoostCompute_BINARY_DIR}/BoostComputeConfig.cmake
  @ONLY
)

# install cmake config file
install(
  FILES ${BoostCompute_BINARY_DIR}/BoostComputeConfig.cmake
  DESTINATION share/cmake/BoostCompute
)

# install header files
install(DIRECTORY include/boost DESTINATION include/compute)

=== example/CMakeLists.txt ===
include_directories(../include)

set(EXAMPLES
  amd_cpp_kernel
  black_scholes
  copy_data
  fizz_buzz
  hello_world
  host_sort
  inline_ptx
  longest_vector
  list_devices
  mapped_view
  memory_limits
  monte_carlo
  point_centroid
  price_cross
  print_vector
  sort_vector
  simple_kernel
  time_copy
  transform_sqrt
  vector_addition
  simple_moving_average
  matrix_transpose
)

# boost library link dependencies
set(EXAMPLE_BOOST_COMPONENTS program_options)
if (${BOOST_COMPUTE_USE_OFFLINE_CACHE})
  set(EXAMPLE_BOOST_COMPONENTS ${EXAMPLE_BOOST_COMPONENTS} system filesystem)
endif()

if(${BOOST_COMPUTE_THREAD_SAFE} AND NOT ${BOOST_COMPUTE_USE_CPP11})
  set(EXAMPLE_BOOST_COMPONENTS ${EXAMPLE_BOOST_COMPONENTS} thread)
endif()

find_package(Boost 1.48 REQUIRED COMPONENTS ${EXAMPLE_BOOST_COMPONENTS})
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

foreach(EXAMPLE ${EXAMPLES})
  add_executable(${EXAMPLE} ${EXAMPLE}.cpp)
  target_link_libraries(${EXAMPLE} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})

  # add example program to list of tests (if testing is enabled)
  if(${BOOST_COMPUTE_BUILD_TESTS})
    add_test("example.${EXAMPLE}" ${EXAMPLE})
  endif()
endforeach()

# opencl test example
add_executable(opencl_test opencl_test.cpp)
target_link_libraries(opencl_test ${OPENCL_LIBRARIES})

# eigen examples
if(${BOOST_COMPUTE_HAVE_EIGEN})
  find_package(Eigen REQUIRED)
  include_directories(SYSTEM ${EIGEN_INCLUDE_DIRS})
  add_executable(batched_determinant batched_determinant.cpp)
  target_link_libraries(batched_determinant ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})
endif()

# opencv examples
if(${BOOST_COMPUTE_HAVE_OPENCV})
  find_package(OpenCV REQUIRED)
  include_directories(SYSTEM ${OpenCV_INCLUDE_DIRS})

  set(OPENCV_EXAMPLES
    k_means
    opencv_flip
    random_walk
    opencv_optical_flow 
    opencv_convolution
    opencv_sobel_filter
    opencv_histogram
  )

  foreach(EXAMPLE ${OPENCV_EXAMPLES})
    add_executable(${EXAMPLE} ${EXAMPLE}.cpp)
    target_link_libraries(${EXAMPLE} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${OpenCV_LIBS})
  endforeach()
endif()

# opengl/vtk examples
if(${BOOST_COMPUTE_HAVE_VTK})
  find_package(VTK REQUIRED)
  include(${VTK_USE_FILE})
  add_executable(opengl_sphere opengl_sphere.cpp)
  target_link_libraries(opengl_sphere ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${VTK_LIBRARIES} GL)
endif()

# qt examples
if(${BOOST_COMPUTE_HAVE_QT})

  # look for Qt4 in the first place
  find_package(Qt4 QUIET)

  if(${QT4_FOUND})
    # build with Qt4
    find_package(Qt4 REQUIRED COMPONENTS QtCore QtGui QtOpenGL)
    set(QT_USE_QTOPENGL TRUE)
    include(${QT_USE_FILE})
  else()

    # look for Qt5
    find_package(Qt5Widgets QUIET)
    
    if(${Qt5Widgets_FOUND})
      # build with Qt5
      find_package(Qt5Core REQUIRED)
      find_package(Qt5Widgets REQUIRED)
      find_package(Qt5OpenGL REQUIRED)
      include_directories(${Qt5OpenGL_INCLUDE_DIRS})
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5OpenGL_EXECUTABLE_COMPILE_FLAGS}")
      set(QT_LIBRARIES ${Qt5OpenGL_LIBRARIES})
    else()
      # no valid Qt framework found
      message(FATAL_ERROR "Error: Did not find Qt4 or Qt5")
    endif()
  endif()

  # required by both versions
  set(CMAKE_AUTOMOC TRUE)
  include_directories(${CMAKE_CURRENT_BINARY_DIR})

  # add examples
  add_executable(qimage_blur qimage_blur.cpp)
  target_link_libraries(qimage_blur ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${QT_LIBRARIES})

  set(QT_OPENGL_EXAMPLES
    mandelbrot
    nbody
    resize_image
  )
  foreach(EXAMPLE ${QT_OPENGL_EXAMPLES})
    add_executable(${EXAMPLE} ${EXAMPLE}.cpp)
    target_link_libraries(${EXAMPLE} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${QT_LIBRARIES} GL)
  endforeach()
endif()

=== perf/CMakeLists.txt ===
include_directories(../include)

set(PERF_BOOST_COMPONENTS system timer chrono)

if (${BOOST_COMPUTE_USE_OFFLINE_CACHE})
  set(PERF_BOOST_COMPONENTS ${PERF_BOOST_COMPONENTS} filesystem)
endif()

if(${BOOST_COMPUTE_THREAD_SAFE} AND NOT ${BOOST_COMPUTE_USE_CPP11})
  set(PERF_BOOST_COMPONENTS ${PERF_BOOST_COMPONENTS} thread)
endif()

find_package(Boost 1.48 REQUIRED COMPONENTS ${PERF_BOOST_COMPONENTS})
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

set(BENCHMARKS
  accumulate
  bernoulli_distribution
  binary_find
  cart_to_polar
  copy_if
  copy_to_device
  count
  discrete_distribution
  erase_remove
  exclusive_scan
  fill
  find_end
  includes
  inner_product
  is_permutation
  is_sorted
  linear_congruential_engine
  max_element
  merge
  mersenne_twister
  next_permutation
  nth_element
  partial_sum
  partition
  partition_point
  prev_permutation
  reverse
  rotate
  rotate_copy
  host_sort
  saxpy
  search
  search_n
  set_difference
  set_intersection
  set_symmetric_difference
  set_union
  sort
  sort_by_key
  sort_float
  stable_partition
  uniform_int_distribution
  unique
  unique_copy
)

foreach(BENCHMARK ${BENCHMARKS})
  set(PERF_TARGET perf_${BENCHMARK})
  add_executable(${PERF_TARGET} perf_${BENCHMARK}.cpp)
  target_link_libraries(${PERF_TARGET} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES})
endforeach()

# stl benchmarks (for comparison)
set(STL_BENCHMARKS
  stl_accumulate
  stl_count
  stl_find_end
  stl_includes
  stl_inner_product
  stl_max_element
  stl_merge
  stl_next_permutation
  stl_partial_sum
  stl_partition
  stl_prev_permutation
  stl_reverse
  stl_rotate
  stl_rotate_copy
  stl_saxpy
  stl_search
  stl_search_n
  stl_set_difference
  stl_set_intersection
  stl_set_symmetric_difference
  stl_set_union
  stl_sort
  stl_stable_partition
  stl_unique
  stl_unique_copy
)

# stl benchmarks which rerquire c++11
if(${BOOST_COMPUTE_USE_CPP11})
  list(APPEND
    STL_BENCHMARKS
    stl_is_permutation
    stl_partition_point
  )
endif()

foreach(BENCHMARK ${STL_BENCHMARKS})
  set(PERF_TARGET perf_${BENCHMARK})
  add_executable(${PERF_TARGET} perf_${BENCHMARK}.cpp)
  target_link_libraries(${PERF_TARGET} ${Boost_LIBRARIES})
endforeach()

# cuda/thrust benchmarks (for comparison)
if(${BOOST_COMPUTE_HAVE_CUDA})
  find_package(CUDA 5.0 REQUIRED)

  set(CUDA_BENCHMARKS
    thrust_accumulate
    thrust_count
    thrust_inner_product
    thrust_partial_sum
    thrust_saxpy
    thrust_sort
    thrust_exclusive_scan
  )

  foreach(BENCHMARK ${CUDA_BENCHMARKS})
    set(PERF_TARGET perf_${BENCHMARK})
    cuda_add_executable(${PERF_TARGET} perf_${BENCHMARK}.cu)
    target_link_libraries(${PERF_TARGET} ${CUDA_LIBRARIES} ${Boost_LIBRARIES})
  endforeach()
endif()

# intel tbb benchmarks (for comparison)
if(${BOOST_COMPUTE_HAVE_TBB})
  find_package(TBB REQUIRED)
  include_directories(SYSTEM ${TBB_INCLUDE_DIRS})

  set(TBB_BENCHMARKS
    tbb_accumulate
    tbb_merge
    tbb_sort
  )

  foreach(BENCHMARK ${TBB_BENCHMARKS})
    set(PERF_TARGET perf_${BENCHMARK})
    add_executable(${PERF_TARGET} perf_${BENCHMARK}.cpp)
    target_link_libraries(${PERF_TARGET} ${TBB_LIBRARIES} ${Boost_LIBRARIES})
  endforeach()
endif()

=== test/CMakeLists.txt ===
include_directories(../include)

set(BOOST_COMPONENTS unit_test_framework)

if (${BOOST_COMPUTE_USE_OFFLINE_CACHE})
  set(BOOST_COMPONENTS ${BOOST_COMPONENTS} system filesystem)
  add_definitions(-DBOOST_COMPUTE_USE_OFFLINE_CACHE)
endif()

if(${BOOST_COMPUTE_THREAD_SAFE} AND NOT ${BOOST_COMPUTE_USE_CPP11})
  set(BOOST_COMPONENTS ${BOOST_COMPONENTS} thread)
endif()

find_package(Boost 1.48 REQUIRED COMPONENTS ${BOOST_COMPONENTS})
add_definitions(-DBOOST_TEST_DYN_LINK)

# enable automatic kernel compilation error messages for tests
add_definitions(-DBOOST_COMPUTE_DEBUG_KERNEL_COMPILATION)

# enable code coverage generation (only with GCC for now)
if(${BOOST_COMPUTE_ENABLE_COVERAGE} AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  add_definitions(-fprofile-arcs -ftest-coverage)
endif()

function(add_compute_test TEST_NAME TEST_SOURCE)
  get_filename_component(TEST_TARGET ${TEST_SOURCE} NAME_WE)
  add_executable(${TEST_TARGET} ${TEST_SOURCE})
  target_link_libraries(${TEST_TARGET}
    ${OPENCL_LIBRARIES}
    ${Boost_LIBRARIES}
  )

  # link with coverage library
  if(${BOOST_COMPUTE_ENABLE_COVERAGE} AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    target_link_libraries(${TEST_TARGET} -fprofile-arcs -ftest-coverage)
  endif()

  add_test(${TEST_NAME} ${TEST_TARGET})
endfunction()

add_compute_test("core.buffer" test_buffer.cpp)
add_compute_test("core.closure" test_closure.cpp)
add_compute_test("core.command_queue" test_command_queue.cpp)
add_compute_test("core.context" test_context.cpp)
add_compute_test("core.device" test_device.cpp)
add_compute_test("core.event" test_event.cpp)
add_compute_test("core.function" test_function.cpp)
add_compute_test("core.image2d" test_image2d.cpp)
add_compute_test("core.image3d" test_image3d.cpp)
add_compute_test("core.image_sampler" test_image_sampler.cpp)
add_compute_test("core.kernel" test_kernel.cpp)
add_compute_test("core.pipe" test_pipe.cpp)
add_compute_test("core.platform" test_platform.cpp)
add_compute_test("core.program" test_program.cpp)
add_compute_test("core.system" test_system.cpp)
add_compute_test("core.type_traits" test_type_traits.cpp)
add_compute_test("core.user_event" test_user_event.cpp)

add_compute_test("utility.extents" test_extents.cpp)
add_compute_test("utility.program_cache" test_program_cache.cpp)
add_compute_test("utility.wait_list" test_wait_list.cpp)

add_compute_test("algorithm.accumulate" test_accumulate.cpp)
add_compute_test("algorithm.adjacent_difference" test_adjacent_difference.cpp)
add_compute_test("algorithm.adjacent_find" test_adjacent_find.cpp)
add_compute_test("algorithm.any_all_none_of" test_any_all_none_of.cpp)
add_compute_test("algorithm.binary_search" test_binary_search.cpp)
add_compute_test("algorithm.copy" test_copy.cpp)
add_compute_test("algorithm.copy_if" test_copy_if.cpp)
add_compute_test("algorithm.count" test_count.cpp)
add_compute_test("algorithm.equal" test_equal.cpp)
add_compute_test("algorithm.equal_range" test_equal_range.cpp)
add_compute_test("algorithm.extrema" test_extrema.cpp)
add_compute_test("algorithm.fill" test_fill.cpp)
add_compute_test("algorithm.find" test_find.cpp)
add_compute_test("algorithm.find_end" test_find_end.cpp)
add_compute_test("algorithm.for_each" test_for_each.cpp)
add_compute_test("algorithm.gather" test_gather.cpp)
add_compute_test("algorithm.generate" test_generate.cpp)
add_compute_test("algorithm.includes" test_includes.cpp)
add_compute_test("algorithm.inner_product" test_inner_product.cpp)
add_compute_test("algorithm.inplace_merge" test_inplace_merge.cpp)
add_compute_test("algorithm.inplace_reduce" test_inplace_reduce.cpp)
add_compute_test("algorithm.insertion_sort" test_insertion_sort.cpp)
add_compute_test("algorithm.iota" test_iota.cpp)
add_compute_test("algorithm.is_permutation" test_is_permutation.cpp)
add_compute_test("algorithm.is_sorted" test_is_sorted.cpp)
add_compute_test("algorithm.merge" test_merge.cpp)
add_compute_test("algorithm.mismatch" test_mismatch.cpp)
add_compute_test("algorithm.next_permutation" test_next_permutation.cpp)
add_compute_test("algorithm.nth_element" test_nth_element.cpp)
add_compute_test("algorithm.partial_sum" test_partial_sum.cpp)
add_compute_test("algorithm.partition" test_partition.cpp)
add_compute_test("algorithm.partition_point" test_partition_point.cpp)
add_compute_test("algorithm.prev_permutation" test_prev_permutation.cpp)
add_compute_test("algorithm.radix_sort" test_radix_sort.cpp)
add_compute_test("algorithm.random_fill" test_random_fill.cpp)
add_compute_test("algorithm.random_shuffle" test_random_shuffle.cpp)
add_compute_test("algorithm.reduce" test_reduce.cpp)
add_compute_test("algorithm.remove" test_remove.cpp)
add_compute_test("algorithm.replace" test_replace.cpp)
add_compute_test("algorithm.reverse" test_reverse.cpp)
add_compute_test("algorithm.rotate" test_rotate.cpp)
add_compute_test("algorithm.rotate_copy" test_rotate_copy.cpp)
add_compute_test("algorithm.scan" test_scan.cpp)
add_compute_test("algorithm.scatter" test_scatter.cpp)
add_compute_test("algorithm.search" test_search.cpp)
add_compute_test("algorithm.search_n" test_search_n.cpp)
add_compute_test("algorithm.set_difference" test_set_difference.cpp)
add_compute_test("algorithm.set_intersection" test_set_intersection.cpp)
add_compute_test("algorithm.set_symmetric_difference" test_set_symmetric_difference.cpp)
add_compute_test("algorithm.set_union" test_set_union.cpp)
add_compute_test("algorithm.sort" test_sort.cpp)
add_compute_test("algorithm.sort_by_key" test_sort_by_key.cpp)
add_compute_test("algorithm.stable_partition" test_stable_partition.cpp)
add_compute_test("algorithm.stable_sort" test_stable_sort.cpp)
add_compute_test("algorithm.transform" test_transform.cpp)
add_compute_test("algorithm.transform_reduce" test_transform_reduce.cpp)
add_compute_test("algorithm.unique" test_unique.cpp)
add_compute_test("algorithm.unique_copy" test_unique_copy.cpp)
add_compute_test("algorithm.lexicographical_compare" test_lexicographical_compare.cpp)

add_compute_test("allocator.buffer_allocator" test_buffer_allocator.cpp)
add_compute_test("allocator.pinned_allocator" test_pinned_allocator.cpp)

add_compute_test("async.wait" test_async_wait.cpp)

add_compute_test("container.array" test_array.cpp)
add_compute_test("container.dynamic_bitset" test_dynamic_bitset.cpp)
add_compute_test("container.flat_map" test_flat_map.cpp)
add_compute_test("container.flat_set" test_flat_set.cpp)
add_compute_test("container.mapped_view" test_mapped_view.cpp)
add_compute_test("container.stack" test_stack.cpp)
add_compute_test("container.string" test_string.cpp)
add_compute_test("container.valarray" test_valarray.cpp)
add_compute_test("container.vector" test_vector.cpp)

add_compute_test("exception.opencl_error" test_opencl_error.cpp)
add_compute_test("exception.context_error" test_context_error.cpp)
add_compute_test("exception.unsupported_extension" test_unsupported_extension.cpp)

add_compute_test("functional.as" test_functional_as.cpp)
add_compute_test("functional.bind" test_functional_bind.cpp)
add_compute_test("functional.convert" test_functional_convert.cpp)
add_compute_test("functional.get" test_functional_get.cpp)
add_compute_test("functional.hash" test_functional_hash.cpp)
add_compute_test("functional.identity" test_functional_identity.cpp)
add_compute_test("functional.popcount" test_functional_popcount.cpp)
add_compute_test("functional.unpack" test_functional_unpack.cpp)

add_compute_test("iterator.buffer_iterator" test_buffer_iterator.cpp)
add_compute_test("iterator.constant_iterator" test_constant_iterator.cpp)
add_compute_test("iterator.counting_iterator" test_counting_iterator.cpp)
add_compute_test("iterator.discard_iterator" test_discard_iterator.cpp)
add_compute_test("iterator.permutation_iterator" test_permutation_iterator.cpp)
add_compute_test("iterator.transform_iterator" test_transform_iterator.cpp)
add_compute_test("iterator.zip_iterator" test_zip_iterator.cpp)

add_compute_test("memory.svm_ptr" test_svm_ptr.cpp)

add_compute_test("random.bernoulli_distribution" test_bernoulli_distribution.cpp)
add_compute_test("random.discrete_distribution" test_discrete_distribution.cpp)
add_compute_test("random.linear_congruential_engine" test_linear_congruential_engine.cpp)
add_compute_test("random.mersenne_twister_engine" test_mersenne_twister_engine.cpp)
add_compute_test("random.normal_distribution" test_normal_distribution.cpp)
add_compute_test("random.uniform_int_distribution" test_uniform_int_distribution.cpp)
add_compute_test("random.uniform_real_distribution" test_uniform_real_distribution.cpp)

add_compute_test("types.builtin" test_types.cpp)
add_compute_test("types.complex" test_complex.cpp)
add_compute_test("types.pair" test_pair.cpp)
add_compute_test("types.tuple" test_tuple.cpp)
add_compute_test("types.struct" test_struct.cpp)

add_compute_test("type_traits.result_of" test_result_of.cpp)

add_compute_test("experimental.clamp_range" test_clamp_range.cpp)
add_compute_test("experimental.malloc" test_malloc.cpp)
add_compute_test("experimental.sort_by_transform" test_sort_by_transform.cpp)
add_compute_test("experimental.tabulate" test_tabulate.cpp)
add_compute_test("experimental.transform_if" test_transform_if.cpp)

add_compute_test("ext.lambda" test_lambda.cpp)
add_compute_test("ext.amd_cpp_kernel_language" test_amd_cpp_kernel_language.cpp)

# eigen interop tests
if(${BOOST_COMPUTE_HAVE_EIGEN})
  find_package(Eigen REQUIRED)
  include_directories(SYSTEM ${EIGEN_INCLUDE_DIRS})
  add_compute_test("interop.eigen" test_interop_eigen.cpp)
endif()

# opencv interop tests
if(${BOOST_COMPUTE_HAVE_OPENCV})
  find_package(OpenCV REQUIRED)
  include_directories(SYSTEM ${OpenCV_INCLUDE_DIRS})
  add_compute_test("interop.opencv" test_interop_opencv.cpp)
  target_link_libraries(test_interop_opencv ${OpenCV_LIBS})
endif()

# qt interop tests
if(${BOOST_COMPUTE_HAVE_QT})
  # look for Qt4 in the first place
  find_package(Qt4 QUIET)

  if(${QT4_FOUND})
    find_package(Qt4 REQUIRED COMPONENTS QtCore QtGui QtOpenGL)
    include(${QT_USE_FILE})
  else()
    find_package(Qt5Widgets QUIET)

    # look for Qt5
    if(${Qt5Widgets_FOUND})
      find_package(Qt5Core REQUIRED)
      find_package(Qt5Widgets REQUIRED)
      find_package(Qt5OpenGL REQUIRED)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5OpenGL_EXECUTABLE_COMPILE_FLAGS}")
      set(QT_LIBRARIES ${Qt5OpenGL_LIBRARIES})
    else()
      # no valid Qt framework found
      message(FATAL_ERROR "Error: Did not find Qt4 or Qt5")
    endif()
  endif()

  add_compute_test("interop.qt" test_interop_qt.cpp)
  target_link_libraries(test_interop_qt ${QT_LIBRARIES})

  # the opengl interop test depends on qt to create the opengl context
  add_compute_test("interop.opengl" test_interop_opengl.cpp)
  target_link_libraries(test_interop_opengl ${QT_LIBRARIES})
endif()

# vtk interop tests
if(${BOOST_COMPUTE_HAVE_VTK})
  find_package(VTK REQUIRED)
  include(${VTK_USE_FILE})
  add_compute_test("interop.vtk" test_interop_vtk.cpp)
  target_link_libraries(test_interop_vtk ${VTK_LIBRARIES})
endif()

# tests for particular bugs/issues
add_compute_test("issue.user_defined_types" test_user_defined_types.cpp)

# Check for linkage problems
add_executable(test_multiple_objects
    test_multiple_objects1.cpp
    test_multiple_objects2.cpp
    )
target_link_libraries(test_multiple_objects
    ${OPENCL_LIBRARIES}
    ${Boost_LIBRARIES}
    )
# link with coverage library
if(${BOOST_COMPUTE_ENABLE_COVERAGE} AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  target_link_libraries(test_multiple_objects -fprofile-arcs -ftest-coverage)
endif()
add_test("issue.multiple_objects" test_multiple_objects)

=== debian/changelog ===
compute (0.4-3) unstable; urgency=medium

  * Install examples to doc package.
  * Add autopkgtest testsuite.
  * d/rules: remove unnecessary buildsystem parameter.
  * Install HTML documentation to doc package.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 03 Dec 2015 11:50:09 +0000

compute (0.4-2) unstable; urgency=medium

  * d/control: fix homepage. (Closes: #797308)
  * d/{control,copyright}: cme fixed.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Thu, 29 Oct 2015 11:11:41 +0000

compute (0.4-1) unstable; urgency=low

  * Initial release. (Closes: #794649)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Mon, 27 Jul 2015 11:11:49 +0100

=== debian/control ===
Source: compute
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: science
Testsuite: autopkgtest
Priority: optional
Build-Depends: cmake,
               debhelper (>= 9),
               docbook-xml,
               docbook-xsl,
               doxygen,
               libboost-dev (>= 1.48),
               libboost-tools-dev,
               ocl-icd-opencl-dev | opencl-dev,
               xsltproc
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/compute.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/compute.git
Homepage: http://boostorg.github.io/compute

Package: libcompute-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends},
         libboost-dev,
         ocl-icd-opencl-dev | opencl-dev
Suggests: libcompute-doc
Description: cross-platform C++ library for GPU computing
 Boost.Compute is a GPU/parallel-computing library for C++ based on OpenCL.
 .
 The core library is a thin C++ wrapper over the OpenCL API and provides access
 to compute devices, contexts, command queues and memory buffers.
 .
 On top of the core library is a generic, STL-like interface providing common
 algorithms (e.g. transform(), accumulate(), sort()) along with common
 containers (e.g. vector<T>, flat_set<T>). It also features a number of
 extensions including parallel-computing algorithms (e.g. exclusive_scan(),
 scatter(), reduce()) and a number of fancy iterators (e.g.
 transform_iterator<>, permutation_iterator<>, zip_iterator<>). 
 .
 This package provides the development files for the standalone compute 
 package.

Package: libcompute-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: documentation and examples for Boost.Compute
 Boost.Compute is a GPU/parallel-computing library for C++ based on OpenCL.
 .
 The core library is a thin C++ wrapper over the OpenCL API and provides access
 to compute devices, contexts, command queues and memory buffers.
 .
 On top of the core library is a generic, STL-like interface providing common
 algorithms (e.g. transform(), accumulate(), sort()) along with common
 containers (e.g. vector<T>, flat_set<T>). It also features a number of
 extensions including parallel-computing algorithms (e.g. exclusive_scan(),
 scatter(), reduce()) and a number of fancy iterators (e.g.
 transform_iterator<>, permutation_iterator<>, zip_iterator<>).
 .
 This package provides the documentation and example source code for the
 standalone compute package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -rf bin doc/bin doc/html
	rm -f doc/*.jam doc/*.xml

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBOOST_COMPUTE_BUILD_BENCHMARKS=OFF \
		-DBOOST_COMPUTE_BUILD_EXAMPLES=OFF \
		-DBOOST_COMPUTE_BUILD_TESTS=OFF

override_dh_auto_build:
	dh_auto_build
	cd doc && \
	printf "using boostbook ;\nusing quickbook ;\nusing doxygen ;" >> ./user-config.jam  && \
	bjam --v2 --user-config=./user-config.jam html

override_dh_compress:
	dh_compress --exclude=examples

## compute 0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,12 @@
+# ---------------------------------------------------------------------------
+#  Copyright (c) 2013 Kyle Lutz <kyle.r.lutz@gmail.com>
+# 
+#  Distributed under the Boost Software License, Version 1.0
+#  See accompanying file LICENSE_1_0.txt or copy at
+#  http://www.boost.org/LICENSE_1_0.txt
+#
+# ---------------------------------------------------------------------------
+
 cmake_minimum_required(VERSION 2.8)
 
 project(BoostCompute)
@@ -14,8 +23,10 @@
 
 # optional support for c++11
 option(BOOST_COMPUTE_USE_CPP11 "Use C++11 features" OFF)
-if(${BOOST_COMPUTE_USE_CPP11})
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+if(NOT MSVC)
+  if(${BOOST_COMPUTE_USE_CPP11})
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+  endif()
 endif()
 
 # optional support for offline-caching
@@ -29,7 +40,13 @@
 if(${BOOST_COMPUTE_THREAD_SAFE})
   add_definitions(-DBOOST_COMPUTE_THREAD_SAFE)
   if(${BOOST_COMPUTE_USE_CPP11})
-    add_definitions(-DBOOST_COMPUTE_HAVE_THREAD_LOCAL)
+    if(MSVC)
+      if (MSVC_VERSION GREATER 1800)
+        add_definitions(-DBOOST_COMPUTE_HAVE_THREAD_LOCAL)
+      endif()
+    else()
+      add_definitions(-DBOOST_COMPUTE_HAVE_THREAD_LOCAL)
+    endif()
   endif()
 endif()
 
@@ -40,6 +57,7 @@
 option(BOOST_COMPUTE_HAVE_VTK "Have VTK" OFF)
 option(BOOST_COMPUTE_HAVE_CUDA "Have CUDA" OFF)
 option(BOOST_COMPUTE_HAVE_TBB "Have TBB" OFF)
+option(BOOST_COMPUTE_HAVE_BOLT "Have BOLT" OFF)
 
 include_directories(include)
 
@@ -48,6 +66,12 @@
 endif()
 
 if(MSVC)
+  # optional support for boost dynamic libraries
+  option(BOOST_COMPUTE_BOOST_ALL_DYN_LINK "Use boost dynamic link libraries" OFF)
+  if(${BOOST_COMPUTE_BOOST_ALL_DYN_LINK})
+    add_definitions(-DBOOST_ALL_DYN_LINK)
+  endif()
+  link_directories(${Boost_LIBRARY_DIRS})
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
   add_definitions(-D_SCL_SECURE_NO_WARNINGS)
 endif()
@@ -81,7 +105,7 @@
 # install cmake config file
 install(
   FILES ${BoostCompute_BINARY_DIR}/BoostComputeConfig.cmake
-  DESTINATION share/cmake/BoostCompute
+  DESTINATION lib/cmake/BoostCompute
 )
 
 # install header files

=== example/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,12 @@
+# ---------------------------------------------------------------------------
+#  Copyright (c) 2013-2014 Kyle Lutz <kyle.r.lutz@gmail.com>
+# 
+#  Distributed under the Boost Software License, Version 1.0
+#  See accompanying file LICENSE_1_0.txt or copy at
+#  http://www.boost.org/LICENSE_1_0.txt
+#
+# ---------------------------------------------------------------------------
+
 include_directories(../include)
 
 set(EXAMPLES
@@ -86,7 +95,12 @@
   find_package(VTK REQUIRED)
   include(${VTK_USE_FILE})
   add_executable(opengl_sphere opengl_sphere.cpp)
-  target_link_libraries(opengl_sphere ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${VTK_LIBRARIES} GL)
+  target_link_libraries(opengl_sphere ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${VTK_LIBRARIES})
+  if(APPLE)
+    target_link_libraries(opengl_sphere "-framework OpenGL")
+  elseif(UNIX)
+    target_link_libraries(opengl_sphere GL)
+  endif()
 endif()
 
 # qt examples
@@ -134,6 +148,11 @@
   )
   foreach(EXAMPLE ${QT_OPENGL_EXAMPLES})
     add_executable(${EXAMPLE} ${EXAMPLE}.cpp)
-    target_link_libraries(${EXAMPLE} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${QT_LIBRARIES} GL)
+    target_link_libraries(${EXAMPLE} ${OPENCL_LIBRARIES} ${Boost_LIBRARIES} ${QT_LIBRARIES})
+    if(APPLE)
+      target_link_libraries(${EXAMPLE} "-framework OpenGL")
+    elseif(UNIX)
+      target_link_libraries(${EXAMPLE} GL)
+    endif()
   endforeach()
 endif()

=== perf/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,15 @@
+# ---------------------------------------------------------------------------
+#  Copyright (c) 2013 Kyle Lutz <kyle.r.lutz@gmail.com>
+# 
+#  Distributed under the Boost Software License, Version 1.0
+#  See accompanying file LICENSE_1_0.txt or copy at
+#  http://www.boost.org/LICENSE_1_0.txt
+#
+# ---------------------------------------------------------------------------
+
 include_directories(../include)
 
-set(PERF_BOOST_COMPONENTS system timer chrono)
+set(PERF_BOOST_COMPONENTS system timer chrono program_options)
 
 if (${BOOST_COMPUTE_USE_OFFLINE_CACHE})
   set(PERF_BOOST_COMPONENTS ${PERF_BOOST_COMPONENTS} filesystem)
@@ -8,6 +17,12 @@
 
 if(${BOOST_COMPUTE_THREAD_SAFE} AND NOT ${BOOST_COMPUTE_USE_CPP11})
   set(PERF_BOOST_COMPONENTS ${PERF_BOOST_COMPONENTS} thread)
+elseif(${BOOST_COMPUTE_HAVE_BOLT} AND ${BOOST_COMPUTE_USE_CPP11})
+  set(PERF_BOOST_COMPONENTS ${PERF_BOOST_COMPONENTS} thread)	
+endif()
+
+if(${BOOST_COMPUTE_HAVE_BOLT} AND ${BOOST_COMPUTE_USE_CPP11})
+  set(PERF_BOOST_COMPONENTS ${PERF_BOOST_COMPONENTS} date_time) 
 endif()
 
 find_package(Boost 1.48 REQUIRED COMPONENTS ${PERF_BOOST_COMPONENTS})
@@ -25,15 +40,14 @@
   erase_remove
   exclusive_scan
   fill
+  find
   find_end
   includes
   inner_product
   is_permutation
   is_sorted
-  linear_congruential_engine
   max_element
   merge
-  mersenne_twister
   next_permutation
   nth_element
   partial_sum
@@ -41,9 +55,12 @@
   partition_point
   prev_permutation
   reverse
+  reverse_copy
   rotate
   rotate_copy
   host_sort
+  random_number_engine
+  reduce_by_key
   saxpy
   search
   search_n
@@ -70,6 +87,7 @@
 set(STL_BENCHMARKS
   stl_accumulate
   stl_count
+  stl_find
   stl_find_end
   stl_includes
   stl_inner_product
@@ -80,6 +98,7 @@
   stl_partition
   stl_prev_permutation
   stl_reverse
+  stl_reverse_copy
   stl_rotate
   stl_rotate_copy
   stl_saxpy
@@ -95,7 +114,7 @@
   stl_unique_copy
 )
 
-# stl benchmarks which rerquire c++11
+# stl benchmarks which require c++11
 if(${BOOST_COMPUTE_USE_CPP11})
   list(APPEND
     STL_BENCHMARKS
@@ -117,11 +136,20 @@
   set(CUDA_BENCHMARKS
     thrust_accumulate
     thrust_count
+    thrust_exclusive_scan
+    thrust_find
     thrust_inner_product
+    thrust_merge
     thrust_partial_sum
+    thrust_partition
+    thrust_reduce_by_key
+    thrust_reverse
+    thrust_reverse_copy
+    thrust_rotate
     thrust_saxpy
+    thrust_set_difference
     thrust_sort
-    thrust_exclusive_scan
+    thrust_unique
   )
 
   foreach(BENCHMARK ${CUDA_BENCHMARKS})
@@ -148,3 +176,31 @@
     target_link_libraries(${PERF_TARGET} ${TBB_LIBRARIES} ${Boost_LIBRARIES})
   endforeach()
 endif()
+
+# bolt c++ template lib benchmarks (for comparison)
+if(${BOOST_COMPUTE_HAVE_BOLT} AND ${BOOST_COMPUTE_USE_CPP11})
+  find_package(Bolt REQUIRED)
+  include_directories(SYSTEM ${BOLT_INCLUDE_DIRS})
+
+  set(BOLT_BENCHMARKS
+    bolt_accumulate
+    bolt_count
+    bolt_exclusive_scan
+    bolt_fill
+    bolt_inner_product
+    bolt_max_element
+    bolt_merge
+    bolt_partial_sum
+    bolt_reduce_by_key
+    bolt_saxpy
+    bolt_sort
+  )
+
+  foreach(BENCHMARK ${BOLT_BENCHMARKS})
+    set(PERF_TARGET perf_${BENCHMARK})
+    add_executable(${PERF_TARGET} perf_${BENCHMARK}.cpp)
+    target_link_libraries(${PERF_TARGET} ${OPENCL_LIBRARIES} ${BOLT_LIBRARIES} ${Boost_LIBRARIES})
+  endforeach()
+elseif(${BOOST_COMPUTE_HAVE_BOLT} AND NOT ${BOOST_COMPUTE_USE_CPP11})
+  message(WARNING "BOOST_COMPUTE_USE_CPP11 must be ON for building Bolt C++ Template Library performance tests.")
+endif()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,20 @@
+# ---------------------------------------------------------------------------
+#  Copyright (c) 2013 Kyle Lutz <kyle.r.lutz@gmail.com>
+# 
+#  Distributed under the Boost Software License, Version 1.0
+#  See accompanying file LICENSE_1_0.txt or copy at
+#  http://www.boost.org/LICENSE_1_0.txt
+#
+# ---------------------------------------------------------------------------
+
 include_directories(../include)
 
 set(BOOST_COMPONENTS unit_test_framework)
+
+if(${BOOST_COMPUTE_USE_CPP11})
+  # allow tests to use C++11 features
+  add_definitions(-DBOOST_COMPUTE_USE_CPP11)
+endif()
 
 if (${BOOST_COMPUTE_USE_OFFLINE_CACHE})
   set(BOOST_COMPONENTS ${BOOST_COMPONENTS} system filesystem)
@@ -45,9 +59,6 @@
 add_compute_test("core.device" test_device.cpp)
 add_compute_test("core.event" test_event.cpp)
 add_compute_test("core.function" test_function.cpp)
-add_compute_test("core.image2d" test_image2d.cpp)
-add_compute_test("core.image3d" test_image3d.cpp)
-add_compute_test("core.image_sampler" test_image_sampler.cpp)
 add_compute_test("core.kernel" test_kernel.cpp)
 add_compute_test("core.pipe" test_pipe.cpp)
 add_compute_test("core.platform" test_platform.cpp)
@@ -57,6 +68,7 @@
 add_compute_test("core.user_event" test_user_event.cpp)
 
 add_compute_test("utility.extents" test_extents.cpp)
+add_compute_test("utility.invoke" test_invoke.cpp)
 add_compute_test("utility.program_cache" test_program_cache.cpp)
 add_compute_test("utility.wait_list" test_wait_list.cpp)
 
@@ -97,6 +109,7 @@
 add_compute_test("algorithm.random_fill" test_random_fill.cpp)
 add_compute_test("algorithm.random_shuffle" test_random_shuffle.cpp)
 add_compute_test("algorithm.reduce" test_reduce.cpp)
+add_compute_test("algorithm.reduce_by_key" test_reduce_by_key.cpp)
 add_compute_test("algorithm.remove" test_remove.cpp)
 add_compute_test("algorithm.replace" test_replace.cpp)
 add_compute_test("algorithm.reverse" test_reverse.cpp)
@@ -104,6 +117,7 @@
 add_compute_test("algorithm.rotate_copy" test_rotate_copy.cpp)
 add_compute_test("algorithm.scan" test_scan.cpp)
 add_compute_test("algorithm.scatter" test_scatter.cpp)
+add_compute_test("algorithm.scatter_if" test_scatter_if.cpp)
 add_compute_test("algorithm.search" test_search.cpp)
 add_compute_test("algorithm.search_n" test_search_n.cpp)
 add_compute_test("algorithm.set_difference" test_set_difference.cpp)
@@ -115,6 +129,7 @@
 add_compute_test("algorithm.stable_partition" test_stable_partition.cpp)
 add_compute_test("algorithm.stable_sort" test_stable_sort.cpp)
 add_compute_test("algorithm.transform" test_transform.cpp)
+add_compute_test("algorithm.transform_if" test_transform_if.cpp)
 add_compute_test("algorithm.transform_reduce" test_transform_reduce.cpp)
 add_compute_test("algorithm.unique" test_unique.cpp)
 add_compute_test("algorithm.unique_copy" test_unique_copy.cpp)
@@ -124,6 +139,7 @@
 add_compute_test("allocator.pinned_allocator" test_pinned_allocator.cpp)
 
 add_compute_test("async.wait" test_async_wait.cpp)
+add_compute_test("async.wait_guard" test_async_wait_guard.cpp)
 
 add_compute_test("container.array" test_array.cpp)
 add_compute_test("container.dynamic_bitset" test_dynamic_bitset.cpp)
@@ -135,8 +151,9 @@
 add_compute_test("container.valarray" test_valarray.cpp)
 add_compute_test("container.vector" test_vector.cpp)
 
+add_compute_test("exception.context_error" test_context_error.cpp)
+add_compute_test("exception.no_device_found" test_no_device_found.cpp)
 add_compute_test("exception.opencl_error" test_opencl_error.cpp)
-add_compute_test("exception.context_error" test_context_error.cpp)
 add_compute_test("exception.unsupported_extension" test_unsupported_extension.cpp)
 
 add_compute_test("functional.as" test_functional_as.cpp)
@@ -148,25 +165,34 @@
 add_compute_test("functional.popcount" test_functional_popcount.cpp)
 add_compute_test("functional.unpack" test_functional_unpack.cpp)
 
+add_compute_test("image.image1d" test_image1d.cpp)
+add_compute_test("image.image2d" test_image2d.cpp)
+add_compute_test("image.image3d" test_image3d.cpp)
+add_compute_test("image.image_sampler" test_image_sampler.cpp)
+
 add_compute_test("iterator.buffer_iterator" test_buffer_iterator.cpp)
 add_compute_test("iterator.constant_iterator" test_constant_iterator.cpp)
 add_compute_test("iterator.counting_iterator" test_counting_iterator.cpp)
 add_compute_test("iterator.discard_iterator" test_discard_iterator.cpp)
+add_compute_test("iterator.function_input_iterator" test_function_input_iterator.cpp)
 add_compute_test("iterator.permutation_iterator" test_permutation_iterator.cpp)
+add_compute_test("iterator.strided_iterator" test_strided_iterator.cpp)
 add_compute_test("iterator.transform_iterator" test_transform_iterator.cpp)
 add_compute_test("iterator.zip_iterator" test_zip_iterator.cpp)
 
+add_compute_test("memory.local_buffer" test_local_buffer.cpp)
 add_compute_test("memory.svm_ptr" test_svm_ptr.cpp)
 
 add_compute_test("random.bernoulli_distribution" test_bernoulli_distribution.cpp)
 add_compute_test("random.discrete_distribution" test_discrete_distribution.cpp)
 add_compute_test("random.linear_congruential_engine" test_linear_congruential_engine.cpp)
 add_compute_test("random.mersenne_twister_engine" test_mersenne_twister_engine.cpp)
+add_compute_test("random.threefry_engine" test_threefry_engine.cpp)
 add_compute_test("random.normal_distribution" test_normal_distribution.cpp)
 add_compute_test("random.uniform_int_distribution" test_uniform_int_distribution.cpp)
 add_compute_test("random.uniform_real_distribution" test_uniform_real_distribution.cpp)
 
-add_compute_test("types.builtin" test_types.cpp)
+add_compute_test("types.fundamental" test_types.cpp)
 add_compute_test("types.complex" test_complex.cpp)
 add_compute_test("types.pair" test_pair.cpp)
 add_compute_test("types.tuple" test_tuple.cpp)
@@ -178,80 +204,11 @@
 add_compute_test("experimental.malloc" test_malloc.cpp)
 add_compute_test("experimental.sort_by_transform" test_sort_by_transform.cpp)
 add_compute_test("experimental.tabulate" test_tabulate.cpp)
-add_compute_test("experimental.transform_if" test_transform_if.cpp)
-
-add_compute_test("ext.lambda" test_lambda.cpp)
-add_compute_test("ext.amd_cpp_kernel_language" test_amd_cpp_kernel_language.cpp)
-
-# eigen interop tests
-if(${BOOST_COMPUTE_HAVE_EIGEN})
-  find_package(Eigen REQUIRED)
-  include_directories(SYSTEM ${EIGEN_INCLUDE_DIRS})
-  add_compute_test("interop.eigen" test_interop_eigen.cpp)
-endif()
-
-# opencv interop tests
-if(${BOOST_COMPUTE_HAVE_OPENCV})
-  find_package(OpenCV REQUIRED)
-  include_directories(SYSTEM ${OpenCV_INCLUDE_DIRS})
-  add_compute_test("interop.opencv" test_interop_opencv.cpp)
-  target_link_libraries(test_interop_opencv ${OpenCV_LIBS})
-endif()
-
-# qt interop tests
-if(${BOOST_COMPUTE_HAVE_QT})
-  # look for Qt4 in the first place
-  find_package(Qt4 QUIET)
-
-  if(${QT4_FOUND})
-    find_package(Qt4 REQUIRED COMPONENTS QtCore QtGui QtOpenGL)
-    include(${QT_USE_FILE})
-  else()
-    find_package(Qt5Widgets QUIET)
-
-    # look for Qt5
-    if(${Qt5Widgets_FOUND})
-      find_package(Qt5Core REQUIRED)
-      find_package(Qt5Widgets REQUIRED)
-      find_package(Qt5OpenGL REQUIRED)
-      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5OpenGL_EXECUTABLE_COMPILE_FLAGS}")
-      set(QT_LIBRARIES ${Qt5OpenGL_LIBRARIES})
-    else()
-      # no valid Qt framework found
-      message(FATAL_ERROR "Error: Did not find Qt4 or Qt5")
-    endif()
-  endif()
-
-  add_compute_test("interop.qt" test_interop_qt.cpp)
-  target_link_libraries(test_interop_qt ${QT_LIBRARIES})
-
-  # the opengl interop test depends on qt to create the opengl context
-  add_compute_test("interop.opengl" test_interop_opengl.cpp)
-  target_link_libraries(test_interop_opengl ${QT_LIBRARIES})
-endif()
-
-# vtk interop tests
-if(${BOOST_COMPUTE_HAVE_VTK})
-  find_package(VTK REQUIRED)
-  include(${VTK_USE_FILE})
-  add_compute_test("interop.vtk" test_interop_vtk.cpp)
-  target_link_libraries(test_interop_vtk ${VTK_LIBRARIES})
-endif()
-
-# tests for particular bugs/issues
-add_compute_test("issue.user_defined_types" test_user_defined_types.cpp)
-
-# Check for linkage problems
-add_executable(test_multiple_objects
-    test_multiple_objects1.cpp
-    test_multiple_objects2.cpp
-    )
-target_link_libraries(test_multiple_objects
-    ${OPENCL_LIBRARIES}
-    ${Boost_LIBRARIES}
-    )
-# link with coverage library
-if(${BOOST_COMPUTE_ENABLE_COVERAGE} AND "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
-  target_link_libraries(test_multiple_objects -fprofile-arcs -ftest-coverage)
-endif()
-add_test("issue.multiple_objects" test_multiple_objects)
+
+# miscellaneous tests
+add_compute_test("misc.amd_cpp_kernel_language" test_amd_cpp_kernel_language.cpp)
+add_compute_test("misc.lambda" test_lambda.cpp)
+add_compute_test("misc.user_defined_types" test_user_defined_types.cpp)
+
+# extra tests (interop tests, linkage tests, etc.)
+add_subdirectory(extra)

=== debian/changelog ===
compute (0.5-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright:
    - Add corresponding entry for new files.
    - Apply `cme fix`, wrap and sort.
  * Drop fix-cmake-config-installdir.patch, applied upstream.
  * d/rules: generate missing Jamroot file for documentation.
  * Conditionally build examples and testsuite via nocheck.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 22 Dec 2015 00:22:36 +0000

=== debian/control ===
--- 
+++ 
@@ -10,6 +10,8 @@
                docbook-xsl,
                doxygen,
                libboost-dev (>= 1.48),
+               libboost-program-options-dev (>= 1.48),
+               libboost-test-dev (>= 1.48),
                libboost-tools-dev,
                ocl-icd-opencl-dev | opencl-dev,
                xsltproc

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

BUILD_OPTIONS = \
	-DBOOST_COMPUTE_BUILD_BENCHMARKS=OFF \
	-DBOOST_COMPUTE_ENABLE_COVERAGE=OFF

# Disable build of examples and testsuite if no check requested.
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
BUILD_OPTIONS += \
	-DBOOST_COMPUTE_BUILD_EXAMPLES=ON \
	-DBOOST_COMPUTE_BUILD_TESTS=ON
else
BUILD_OPTIONS += \
	-DBOOST_COMPUTE_BUILD_EXAMPLES=OFF \
	-DBOOST_COMPUTE_BUILD_TESTS=OFF
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -rf bin doc/bin doc/html
	rm -f Jamroot doc/*.jam doc/*.xml

override_dh_auto_configure:
	dh_auto_configure -- $(BUILD_OPTIONS)

override_dh_auto_build:
	dh_auto_build
	echo 'project compute : ;' > Jamroot
	cd doc && \
	printf "using boostbook ;\nusing quickbook ;\nusing doxygen ;" >> ./user-config.jam  && \
	bjam --v2 --user-config=./user-config.jam html

override_dh_auto_test:
	# No-op.

override_dh_compress:
	dh_compress --exclude=examples

=== debian/tests/control ===
Tests: build-examples
Depends: build-essential,
         cmake,
         libboost-program-options-dev,
         libcompute-dev,
         libcompute-doc
Restrictions: allow-stderr

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/compute-$1\.tar\.gz/ \
  https://github.com/boostorg/compute/tags .*/v?(\d\S*)\.tar\.gz
